<script src="https://cdn.jsdelivr.net/npm/algoliasearch@4.8.5/dist/algoliasearch.umd.js" integrity="sha256-gyk3c0Wg6fTf02Ohy/5CWfdqL+m/9pPXB+2sgfxN+vo=" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/instantsearch.js@4.16.1/dist/instantsearch.production.min.js" integrity="sha256-AYwEMXJiYzczpzHSQHQfViSoIAO6MsabCYKK+T3dyL8=" crossorigin="anonymous"></script>
<script src="https://unpkg.com/dayjs@1.8.21/dayjs.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/ramda@0.25.0/dist/ramda.min.js"></script>

<div class="dropdown">
  <div onclick="toggleMenu()" id="searchbox"></div>
  <div id="menu-searchbox" class="dropdown-container">
    <div class='dropdown-content'>
      <div class="close-menu">
        <button onclick="toggleMenu()" class="button-close-menu">
          <i class="fas fa-times"></i>
        </button>
      </div>
      <div class='dropwon-header'>
        <div id="stats"></div>
        <div class="agolia-logo">
          <img src="/documentation/images/search-by-algolia-light-background.png" alt="search by algolia">
        </div>
      </div>
      <div id="hits"></div>
      <div id="pagination"></div>
    </div>
  </div>
</div>

<script>
const menuBox = document.getElementById('menu-searchbox');    

const toggleMenu = () => {  
  if(menuBox.style.display == "block") { // if is menuBox displayed, hide it
    menuBox.style.display = "none";
  }
  else { // if is menuBox hidden, display it
    menuBox.style.display = "block";
  }
}

$(document).keyup((e) => {
  if (e.keyCode == 27) { // escape key maps to keycode `27`
    menuBox.style.display = "none";
 }
});

var search = instantsearch({
  indexName: '{{ .Site.Params.algolia_indexName }}',
  searchClient: algoliasearch(
    '{{ .Site.Params.algolia_appId }}',
    '{{ .Site.Params.algolia_apiKey }}'
  ),
  routing: true,
});

const renderHits = (renderOptions, isFirstRender) => {
  const { hits } = renderOptions;
  document.querySelector('#hits').innerHTML = R.pipe(
    R.map((item) => {
      const { _highlightResult } = item;
      const keywords = R.zip(
        R.pipe(R.propOr([], 'keywords'), R.splitEvery(2), R.map(R.pipe(R.head, R.prop('value'))))(_highlightResult),
        R.pipe(R.when(R.isNil, R.always([])), R.splitEvery(2), R.map(R.last))(item.keywords)
      )
      return `
        <div class="ais-Hits-item">
          <h3>
            <a href="${ item.permalink }">${ _highlightResult.title.value || item.content.substring( 0, 10 )+ '...' }</a>
          </h3>
          <p>
            <span class="lastmod">${ dayjs(item.lastmod).format("YYYY/MM/DD") }</span>
            - ${ _highlightResult.content.value.length > 200 
                ? _highlightResult.content.value.substring( 0, 200 ) + '...'
                : _highlightResult.content.value 
              }
          </p>
          <div class="keywords">
            ${R.pipe(
                R.map((keyword) => {
                  const [label, link] = keyword;
                  const url = R.pipe(R.head, R.equals('#'))(link) 
                    ? R.pipe(R.slice(0, -1), R.flip(R.concat)(link))(item.permalink)
                    : link;
                  return `<a href="${url}">${label}</a>`;
                }),
                R.join(' - ')
              )(keywords)}
          </div>
        </div>
      `;
    }),
    R.join('')
  )(hits);
};

const customHits = instantsearch.connectors.connectHits( renderHits );

search.addWidgets([
  instantsearch.widgets.searchBox({
    container: '#searchbox',
    placeholder: 'Search by keywords',
    showReset: false,
  }),
  
  instantsearch.widgets.stats({
    container: '#stats',
  }),

  customHits({
    container: document.querySelector('#hits'),
  }),

  instantsearch.widgets.pagination({
    container: '#pagination',
    maxPages: 20
  })
]);

search.start();

</script>
